﻿### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ###
### PowerScript Code Smells Analyzer 
###
### Description (per line)
### Get-ChildItem     Finds all PB source files (within folder = WS_OBJECTS)
### Select-String #1  Finds all functions returning INTEGER
### Select-String #2  Removes "duplicates" leaving only "forward" definitions
###                   The "implementation" of each function has semicolon within its header line
### Select ...        Extracts relevant data
###                   Includes "alias" names for specific data
### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ### ###

### --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---
### This PowerShell script by Michael Kramer is licensed under a
### Creative Commons Attribution 4.0 International License.
###
### To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/.
### --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- ---

### CODE SMELL :: Function returns INTEGER
Get-ChildItem '.\ws_objects' -Recurse -Include *.sr* `
    |Select-String -Pattern '^(public|protected|private) function integer ' `
    |Select-String -NotMatch ';' `
    |Select Filename, `
            @{Name='Line';     Expression={$_.linenumber}}, `
            @{Name='Function'; Expression={$_.Line}}